
var currentTime, deltaTime, appStatus = -1,

APPSTATUS_LOADING = -1, APPSTATUS_MAINMENU = 0, APPSTATUS_GAME = 1, APPSTATUS_PAUSED = 2, APPSTATUS_GAMEOVER = 3;



//DOM loaded, program entry point
document.addEventListener("DOMContentLoaded",function() {
	//initialize systems
	if (!InitializeGraphics()) return;
	InitializeRendering();
	InitializeUI();
	InitializePhysics();
	InitializeAudio();
	InitializeInput();
	InitializeGame();
	
	IndexedStorage_Open("ThatFruitGame", function() {
		IndexedStorage_Load("Save", function(nm, data) {
			if (data) {
				//load existing save
				data = JSON.parse(data);
				sfxVolume.value = sfxAudio.volume = data["s"];
				musicVolume.value = music.volume = data["m"];
				combineSlider.value = combineEffectOn = data["c"];
				highscores = data["h"];
				UpdateHighScores();
				
			} else {
				//no save, new default data
				sfxVolume.value = sfxAudio.volume = 1;
				musicVolume.value = music.volume = 0.5;
				combineSlider.value = combineEffectOn = 1;
			}
			FinishLoading();
		});
	});
});


//finish loading, close loading screen open main panel
function FinishLoading() {
	EV(loadingPanel,false);
	EV(mainMenuPanel,true);
	
	currentTime = Date.now();
	requestAnimationFrame(MainLoop);
}


//save highscores and settings
function SaveState() {
	IndexedStorage_Store("Save", JSON.stringify({"s":sfxAudio.volume, "m":music.volume, "c":combineEffectOn, "h":highscores}));
}


//main update and rendering loop
function MainLoop() {
	var newTime = Date.now();
	deltaTime = (newTime-currentTime)/1000;
	currentTime = newTime;

	if (appStatus === APPSTATUS_GAME) Update();
	Render();

	requestAnimationFrame(MainLoop);
}
