
var wavAudioSupport = false,
music, sfxAudio, playingSfx = -1,

SFX_DROP0 = 0, SFX_DROP1 = 1, SFX_DROP2 = 2, SFX_COMBINE = 3,
SFX_TIMES = [[0,0.82], [1,1.52], [1.6,1.898], [2,3]];


//load audio effects
function InitializeAudio() {
	sfxAudio = new Audio();
	wavAudioSupport = (sfxAudio.canPlayType("audio/wav") ? true : false);
	sfxAudio.src = AudioSrc("Audio/Sfx");
	sfxAudio.load();
	
	music = new Audio();
	music.src = "Audio/Music.mp3";
	music.loop = true;
	music.load();
}


//return audio src path wav/mp3 depending on supported
function AudioSrc(file) {
	return file+(wavAudioSupport ? ".wav" : ".mp3");
}


//play sound effect
function PlaySfx(sfxId) {
	if (sfxAudio.volume < 0.01) return;
	playingSfx = sfxId;
	sfxAudio.currentTime = SFX_TIMES[sfxId][0];
	sfxAudio.play();
}


//update audio
function UpdateAudio() {
	//stop sfx when done
	if (playingSfx > -1 && sfxAudio.currentTime >= SFX_TIMES[playingSfx][1]) {
		sfxAudio.pause();
		playingSfx = -1;
	}
}


//stop playing audio
function StopAudio() {
	sfxAudio.pause();
	playingSfx = -1;
	music.pause();
}

