

var cNormalX = 0, cNormalY = 0, collisionPool, energyChainPool, firstEnergyChain = null, lastEnergyChain = null,

FRUIT_SHAPES = new Array(10), FRUIT_THICKNESS = new Array(10),
WALL_BOUNCE = 0.4, WALL_FRICTION = 1,
GRAVITY = -0.6;

var stopSpawning = false;
function InitializePhysics() {
	//initialize fruit colliders
	//blueberry
	FRUIT_SHAPES[0] = null;
	FRUIT_THICKNESS[0] = 0.035;
	
	//raspberry
	FRUIT_SHAPES[1] = null;
	FRUIT_THICKNESS[1] = 0.055;
	
	//strawberry
	var sz = 0.034;
	FRUIT_SHAPES[2] = new Collider([-sz,sz*0.8, 0,sz*1.1, sz,sz*0.8, 0,-sz*1.1], true);
	FRUIT_THICKNESS[2] = 0.046;
	
	//lime
	sz = 0.107;
	var arcPts = 3, fpts = new Array(4+arcPts*2), fpi = 4, szy = -0.026;
	fpts[0] = -sz; fpts[1] = szy;
	fpts[2] = sz; fpts[3] = szy;
	for (var i = 0; i < arcPts; i++) {
		var ang = (0.5 - (i+0.5)/arcPts)*Math.PI*0.7;
		fpts[fpi++] = Math.sin(ang)*sz;
		fpts[fpi++] = Math.cos(ang)*-sz;
	}
	FRUIT_SHAPES[3] = new Collider(fpts, true);
	FRUIT_THICKNESS[3] = 0.01;
	
	//kiwi
	FRUIT_SHAPES[4] = new Collider([-0.02,0, 0.02,0], false);
	FRUIT_THICKNESS[4] = 0.121;
	
	//apple
	sz = 0.09;
	FRUIT_SHAPES[5] = new Collider([-sz,sz, sz,sz, sz*0.7,-sz*0.8, -sz*0.7,-sz*0.8], true);
	FRUIT_THICKNESS[5] = 0.07;
	
	//banana
	arcPts = 6;
	fpts = new Array(arcPts*2);
	fpi = 0;
	for (var i = 0; i < arcPts; i++) {
		var by = ((i+0.5)/arcPts - 0.5)*0.5,
			bx = by*by*2.6;
		if (by > 0) {
			bx *= 1.1;
		}
		fpts[fpi++] = bx;
		fpts[fpi++] = by;
	}
	FRUIT_SHAPES[6] = new Collider(fpts, false);
	FRUIT_THICKNESS[6] = 0.05;
	
	//mango
	FRUIT_SHAPES[7] = new Collider([0,0.047, 0.02,-0.047, -0.02,-0.047], true);
	FRUIT_THICKNESS[7] = 0.15;
	
	//watermelon
	arcPts = 5;
	fpts = new Array(2+arcPts*2);
	fpi = 2;
	fpts[0] = 0.075; fpts[1] = 0;
	for (var i = 0; i < arcPts; i++) {
		var ang = (0.5 - i/(arcPts-1))*Math.PI*0.26;
		fpts[fpi++] = Math.cos(ang)*0.65;
		fpts[fpi++] = Math.sin(ang)*0.65;
	}
	FRUIT_SHAPES[8] = new Collider(fpts, true);
	FRUIT_THICKNESS[8] = 0.01;

	//pineapple	
	FRUIT_SHAPES[9] = null;
	FRUIT_THICKNESS[9] = 0.35;
	
	
	//collision object pool
	collisionPool = new ObjectPool(Collision);
	energyChainPool = new ObjectPool(PhysicsEnergyChain);
	
	
	/*spawn two specific fruits flying into each other for debugging*/
	var fr = new Fruit();
	fr.x = 0;
	fr.y = -0.3;
	fr.yVel = -0.1;
	fr.xVel = 0;
	fr.angVel = 5;
	fr.LoadID(1);
	//fr.mass = 1;
	//fruits.push(fr);
	
	fr = new Fruit();
	fr.x = 0;
	fr.y = 0.3;
	fr.angVel = 0;
	fr.angle = 0;
	fr.yVel = 0;
	fr.LoadID(1);
	fr.mass = 1;
	//fruits.push(fr);
	
	/*for (var i = 0; i < 4; i++) {
		var fr = new Fruit();
		fr.x = 0;
		fr.y = -0.5+i/3;
		fr.yVel = 0.2;
		fr.xVel = 0.4*((i%2)*2-1);
		fr.LoadID(2+i);
		fruits.push(fr);
	}
	console.log("Starting energy "+PhysicsEnergy());*/
	
	/*drop and spawn fruits repeatedly for debugging*/
	var spawnFruits;
	spawnFruits = function() {
		var fr = new Fruit();
		//fr.x = (Math.random()-0.5)*0.3;
		//fr.y = 0.7;
		fr.x = Math.random()*2-1;
		fr.y = (Math.random()*2-1)*1.5;
		fr.angle = Math.random()*10;
		fr.LoadID(Math.floor(Math.pow(fruits.length/45, 2)*10));//Math.floor(Math.random()*10));
		fruits.push(fr);
		
		if (!stopSpawning && fruits.length < 45) setTimeout(spawnFruits,500);
	};
	//spawnFruits();
	

	/*render collider distance field for debugging
	
	var fr = new Fruit();
	fr.x = 0;
	fr.y = 0;
	fr.LoadID(5);
	fruits.push(fr);
	
	var vcanvas = document.createElement("canvas"),
		v2d = vcanvas.getContext("2d"), wt = window.innerWidth, ht = window.innerHeight;
	vcanvas.width = wt; vcanvas.height = ht;
	
	var vdat = v2d.getImageData(0,0,wt,ht), vpx = vdat.data, pxi = 0,
		colliders = FRUIT_SHAPES[fruits[0].fruitId], thickness = FRUIT_THICKNESS[testFruit];
	for (var y = 0; y < ht; y++) {
		var worldY = ((y/ht)*2-1)*-aspectY;
		for (var x = 0; x < wt; x++) {
			var worldX = ((x/wt)*2-1)*aspectX, dst = 1e16;
			if (colliders) {
				dst = colliders.Nearest(worldX,worldY);

			} else {
				dst = Math.sqrt(worldX*worldX+worldY*worldY);
			}
			dst -= thickness;
			var adst = Math.abs(dst), sgn = dst<0?0:1, isgn = 1-sgn,
				surface = adst < 0.002 ? 255 : 0,
				mask = (adst/0.04+0.5)%1 > 1 ? 255 : 0;
				
			if (worldX*worldX+worldY*worldY < 0.00001) {
				vpx[pxi++] = 255;
				vpx[pxi++] = 0;
				vpx[pxi++] = 255;
				vpx[pxi++] = 190;	
				continue;	
			}
				
			vpx[pxi++] = Math.max(surface,mask*sgn);
			vpx[pxi++] = Math.max(surface,mask*isgn);
			vpx[pxi++] = surface;
			vpx[pxi++] = Math.max(surface, mask);
		}
	}
	v2d.putImageData(vdat,0,0);
	vcanvas.style.cssText = "position: absolute; left:0px;top:0px; z-index: 10;";
	document.body.appendChild(vcanvas);*/
}

//test total energy, for debugging physics instability
function PhysicsEnergy() {
	var sum = 0;
	for (var i = 0; i < fruits.length; i++) {
		var fr = fruits[i];
		sum += (Math.sqrt(fr.xVel*fr.xVel + fr.yVel*fr.yVel) + Math.abs(fr.angVel)*fr.boundsRadius)*fr.mass;
	}
	return sum;
}



//tick physics
function UpdatePhysics() {
	//movement step
	var fruitLen = fruits.length;
	for (var i = 0; i < fruitLen; i++) {
		var fr = fruits[i];
		
		//gravity
		fr.yVel += TICK_STEP*GRAVITY;

		//movement step
		fr.newX = fr.x+fr.xVel*TICK_STEP;
		fr.newY = fr.y+fr.yVel*TICK_STEP;
		fr.angle += fr.angVel*TICK_STEP;
		fr.newCos = Math.cos(fr.angle);
		fr.newSin = Math.sin(fr.angle);
		
		fr.oldXVel = fr.xVel; fr.oldYVel = fr.yVel;
		fr.oldAngVel = fr.angVel;
		
		//reset collisions/forces for this ticks calculation
		fr.totalCollisions = fr.repelX = fr.repelY = fr.minRepX = fr.maxRepX = fr.minRepY = fr.maxRepY = 0;
		
		var fcol = fr.collisions;
		for (var k = 0, kl = fcol.length; k < kl; k++) collisionPool.Return(fcol[k]);
		fcol.length = 0;
	}

	//find collisions
	for (var i = 0; i < fruitLen; i++) {
		var fr = fruits[i], aCollider = fr.collider,
			frx = fr.newX, fry = fr.newY, frRadius = fr.boundsRadius;
		
		//fruit vs boundary walls
		var boundsX = 0.6-Math.abs(frx), boundsY = 1-Math.abs(fry),
			boundsDst = Math.min(boundsX,boundsY);
		if (boundsDst < frRadius) {
			if (aCollider) {
				//collider vs walls
				var aX = 0, aY = 0, anrmX = 0, anrmY = 0, aCount = 0,
					aCos = fr.newCos, aSin = fr.newSin,
					pts = aCollider.points, pi = 0, lineCount = aCollider.lineCount,
					thick = fr.thickness;
				if (!aCollider.closed) lineCount++;
				
				for (var p = 0; p < lineCount; p++) {
					var tpx = pts[pi++], tpy = pts[pi++],
						lpx = tpx*aCos + tpy*aSin, lpy = tpx*-aSin + tpy*aCos,
						px = frx+lpx, py = fry+lpy,
						bpx = 0.6-Math.abs(px), bpy = 1-Math.abs(py),
						
						diffX = -Math.sign(px)*Math.max(0,thick-bpx),
						diffY = -Math.sign(py)*Math.max(0,thick-bpy),
						diffLen = Math.sqrt(diffX*diffX+diffY*diffY);
					if (diffLen > 0) {
						fr.repelX += diffX; fr.repelY += diffY;
						fr.maxRepX = Math.max(fr.maxRepX,diffX); fr.minRepX = Math.min(fr.minRepX,diffX);
						fr.maxRepY = Math.max(fr.maxRepY,diffY); fr.minRepY = Math.min(fr.minRepY,diffY);

						if (diffLen) {
							diffX /= diffLen;
							diffY /= diffLen;
						}
						anrmX += diffX; anrmY += diffY;

						aX += lpx-diffX*thick;
						aY += lpy-diffY*thick;
						aCount++;
						
						//detect fruit hit limit
						if (diffY < -0.7 && fr !== lastDropped) fruitHitLimit = true;
					}
				}
				
				if (aCount > 0) {
					var nrmLen = Math.sqrt(anrmX*anrmX+anrmY*anrmY),
						col = collisionPool.Get();
					if (nrmLen) {
						anrmX /= nrmLen;
						anrmY /= nrmLen;
					}
						
					col.hit = null;
					col.x = aX/aCount; col.y = aY/aCount;

					col.normalX = anrmX; col.normalY = anrmY;
					fr.collisions.push(col);
					fr.totalCollisions++;
				}
			
			} else {
				//circle vs walls
				var col = collisionPool.Get(),
					diffX = -Math.sign(frx)*Math.max(0,frRadius-boundsX),
					diffY = -Math.sign(fry)*Math.max(0,frRadius-boundsY),
					diffLen = Math.sqrt(diffX*diffX+diffY*diffY);
					
				col.hit = null;
				fr.repelX += diffX; fr.repelY += diffY;
				fr.maxRepX = Math.max(fr.maxRepX,diffX); fr.minRepX = Math.min(fr.minRepX,diffX);
				fr.maxRepY = Math.max(fr.maxRepY,diffY); fr.minRepY = Math.min(fr.minRepY,diffY);
				
				if (diffLen) {
					diffX /= diffLen;
					diffY /= diffLen;
				}
				col.normalX = diffX;
				col.normalY = diffY;
				col.x = -diffX*frRadius;
				col.y = -diffY*frRadius;
				
				if (diffY < -0.7 && fr !== lastDropped) fruitHitLimit = true;

				fr.collisions.push(col);
				fr.totalCollisions++;
			}
		}
		
		//fruit vs fruit	
		for (var k = i+1; k < fruitLen; k++) {
			var frb = fruits[k], diffX = frx-frb.newX, diffY = fry-frb.newY,
				cdst = Math.sqrt(diffX*diffX+diffY*diffY),
				bdst = cdst-frRadius-frb.boundsRadius;
			if (bdst < 0) {
				var bCollider = frb.collider;
				
				if (aCollider || bCollider) {
					var aaX = 0, aaY = 0, abX = 0, abY = 0, anrmX = 0, anrmY = 0, aCount = 0,
						aCos = fr.newCos, aSin = fr.newSin, bCos = frb.newCos, bSin = frb.newSin;
					if (aCollider) {
						if (bCollider) {
							var pts = aCollider.points, pi = 0, lineCount = aCollider.lineCount,
								boundThick = fr.thickness+frb.boundsRadius, totalThick = fr.thickness+frb.thickness;
							if (!aCollider.closed) lineCount++;
							
							//collider A points vs collider B
							for (var p = 0; p < lineCount; p++) {
								var lax = pts[pi++], lay = pts[pi++],
									pax = lax*aCos + lay*aSin, pay = lax*-aSin + lay*aCos,
									
									lbx = diffX+pax, lby = diffY+pay,
									pbx = lbx*bCos - lby*bSin, pby = lbx*bSin + lby*bCos,
									
									pDst = Math.sqrt(pbx*pbx+pby*pby);
								if (pDst < boundThick) {
									var pcDst = bCollider.Nearest(pbx,pby)-totalThick;
									if (pcDst < 0) {
										var wnrmX = cNormalX*bCos + cNormalY*bSin,
											wnrmY = cNormalX*-bSin + cNormalY*bCos,
											surfDst = -fr.thickness;
										anrmX += wnrmX; anrmY += wnrmY;
										aaX += pax+wnrmX*surfDst; aaY += pay+wnrmY*surfDst;
										surfDst = -(pcDst+fr.thickness);
										abX += lbx+wnrmX*surfDst; abY += lby+wnrmY*surfDst;
										aCount++;
										
										pcDst *= 0.5;
										var repX = wnrmX*pcDst, repY = wnrmY*pcDst;
										fr.repelX -= repX; fr.repelY -= repY;
										fr.maxRepX = Math.max(fr.maxRepX,-repX); fr.minRepX = Math.min(fr.minRepX,-repX);
										fr.maxRepY = Math.max(fr.maxRepY,-repY); fr.minRepY = Math.min(fr.minRepY,-repY);
										
										frb.repelX += repX; frb.repelY += repY;
										frb.maxRepX = Math.max(frb.maxRepX,repX); frb.minRepX = Math.min(frb.minRepX,repX);
										frb.maxRepY = Math.max(frb.maxRepY,repY); frb.minRepY = Math.min(frb.minRepY,repY);
									}
								}
							}
							
							//collider B points vs collider A
							pts = bCollider.points; pi = 0; lineCount = bCollider.lineCount;
							boundThick = frb.thickness+frRadius;
							if (!bCollider.closed) lineCount++;
							
							for (var p = 0; p < lineCount; p++) {
								var lbx = pts[pi++], lby = pts[pi++],
									pbx = lbx*bCos + lby*bSin, pby = lbx*-bSin + lby*bCos,
									
									lax = -diffX+pbx, lay = -diffY+pby,
									pax = lax*aCos - lay*aSin, pay = lax*aSin + lay*aCos,
									
									pDst = Math.sqrt(pax*pax+pay*pay);
								if (pDst < boundThick) {
									var pcDst = aCollider.Nearest(pax,pay)-totalThick;
									if (pcDst < 0) {
										var wnrmX = cNormalX*aCos + cNormalY*aSin,
											wnrmY = cNormalX*-aSin + cNormalY*aCos,
											surfDst = frb.thickness;
										anrmX -= wnrmX; anrmY -= wnrmY;
										abX += pbx+wnrmX*surfDst; abY += pby+wnrmY*surfDst;
										surfDst = pcDst+frb.thickness;
										aaX += lax+wnrmX*surfDst; aaY += lay+wnrmY*surfDst;
										aCount++;
										
										pcDst *= 0.5;
										var repX = wnrmX*pcDst, repY = wnrmY*pcDst;
										fr.repelX += repX; fr.repelY += repY;
										fr.maxRepX = Math.max(fr.maxRepX,repX); fr.minRepX = Math.min(fr.minRepX,repX);
										fr.maxRepY = Math.max(fr.maxRepY,repY); fr.minRepY = Math.min(fr.minRepY,repY);
										
										frb.repelX -= repX; frb.repelY -= repY;
										frb.maxRepX = Math.max(frb.maxRepX,-repX); frb.minRepX = Math.min(frb.minRepX,-repX);
										frb.maxRepY = Math.max(frb.maxRepY,-repY); frb.minRepY = Math.min(frb.minRepY,-repY);
									}
								}
							}
						
						} else {
							//collider A vs circle B
							var laX = -diffX*aCos + diffY*aSin,
								laY = -diffX*aSin - diffY*aCos;
						
							var acDst = aCollider.Nearest(laX,laY),
								tDst = acDst-(fr.thickness+frb.thickness);
							if (tDst < 0) {
								anrmX = -(cNormalX*aCos + cNormalY*aSin);
								anrmY = -(cNormalX*-aSin + cNormalY*aCos);
								
								var surfDst = frb.thickness;
								abX = anrmX*surfDst; abY = anrmY*surfDst;
								acDst -= fr.thickness;
								aaX = -diffX + anrmX*acDst; aaY = -diffY + anrmY*acDst;
								aCount = 1;
								
								tDst *= 0.5;
								var repX = anrmX*tDst, repY = anrmY*tDst;
								fr.repelX -= repX; fr.repelY -= repY;
								fr.maxRepX = Math.max(fr.maxRepX,-repX); fr.minRepX = Math.min(fr.minRepX,-repX);
								fr.maxRepY = Math.max(fr.maxRepY,-repY); fr.minRepY = Math.min(fr.minRepY,-repY);
								
								frb.repelX += repX; frb.repelY += repY;
								frb.maxRepX = Math.max(frb.maxRepX,repX); frb.minRepX = Math.min(frb.minRepX,repX);
								frb.maxRepY = Math.max(frb.maxRepY,repY); frb.minRepY = Math.min(frb.minRepY,repY);
							}
						}
						
					} else if (bCollider) {
						//circle A vs collider B
						var lbX = diffX*bCos - diffY*bSin,
							lbY = diffX*bSin + diffY*bCos;
						
						var bcDst = bCollider.Nearest(lbX,lbY),
							tDst = bcDst-(fr.thickness+frb.thickness);
						if (tDst < 0) {
							anrmX = cNormalX*bCos + cNormalY*bSin;
							anrmY = cNormalX*-bSin + cNormalY*bCos;
							var surfDst = -fr.thickness;
							aaX = anrmX*surfDst; aaY = anrmY*surfDst;
							bcDst -= frb.thickness;
							abX = diffX - anrmX*bcDst; abY = diffY - anrmY*bcDst;
							aCount = 1;
							
							tDst *= 0.5;
							var repX = anrmX*tDst, repY = anrmY*tDst;
							fr.repelX -= repX; fr.repelY -= repY;
							fr.maxRepX = Math.max(fr.maxRepX,-repX); fr.minRepX = Math.min(fr.minRepX,-repX);
							fr.maxRepY = Math.max(fr.maxRepY,-repY); fr.minRepY = Math.min(fr.minRepY,-repY);
							
							frb.repelX += repX; frb.repelY += repY;
							frb.maxRepX = Math.max(frb.maxRepX,repX); frb.minRepX = Math.min(frb.minRepX,repX);
							frb.maxRepY = Math.max(frb.maxRepY,repY); frb.minRepY = Math.min(frb.minRepY,repY);
						}
					}
					
					if (aCount > 0) {
						var nrmLen = Math.sqrt(anrmX*anrmX+anrmY*anrmY),
							col = collisionPool.Get();
						if (nrmLen) {
							anrmX /= nrmLen;
							anrmY /= nrmLen;
						}
							
						col.x = aaX/aCount; col.y = aaY/aCount;
						col.normalX = anrmX; col.normalY = anrmY;
					
						col.hit = frb;
						col.hitX = abX/aCount; col.hitY = abY/aCount;
						
						fr.collisions.push(col);
						fr.totalCollisions++;
						frb.totalCollisions++;
					}
					
					
				} else {
					//circle vs circle
					var col = collisionPool.Get();
					diffX /= cdst; diffY /= cdst;
					
					bdst *= 0.5;
					var repX = diffX*bdst, repY = diffY*bdst;
					col.x = diffX*-frRadius; col.y = diffY*-frRadius;
					col.normalX = diffX; col.normalY = diffY;
					
					col.hit = frb;
					var surfDst = frb.thickness;
					col.hitX = diffX*surfDst; col.hitY = diffY*surfDst;
					
					fr.repelX -= repX; fr.repelY -= repY;
					fr.maxRepX = Math.max(fr.maxRepX,-repX); fr.minRepX = Math.min(fr.minRepX,-repX);
					fr.maxRepY = Math.max(fr.maxRepY,-repY); fr.minRepY = Math.min(fr.minRepY,-repY);
					
					frb.repelX += repX; frb.repelY += repY;
					frb.maxRepX = Math.max(frb.maxRepX,repX); frb.minRepX = Math.min(frb.minRepX,repX);
					frb.maxRepY = Math.max(frb.maxRepY,repY); frb.minRepY = Math.min(frb.minRepY,repY);
					
					fr.collisions.push(col);
					fr.totalCollisions++;
					frb.totalCollisions++;
				}
			}
		}
	}

	
	//apply collision response
	var maxDropForce = 0;
	for (var i = 0; i < fruitLen; i++) {
		var fr = fruits[i];
		if (fr.totalCollisions) {
			//repel position to solve collisions
			var lastX = fr.x, lastY = fr.y;
			fr.x = fr.newX+Math.max(fr.minRepX, Math.min(fr.maxRepX,fr.repelX));
			fr.y = fr.newY+Math.max(fr.minRepY, Math.min(fr.maxRepY,fr.repelY));
			
			//average 2 frames during collisions to reduce jittering
			fr.drawX = (fr.x+lastX)*0.5;
			fr.drawY = (fr.y+lastY)*0.5;
		
		} else {
			fr.drawX = fr.x = fr.newX;
			fr.drawY = fr.y = fr.newY;
		}

		//collision velocity response
		var cols = fr.collisions, colsLen = cols.length;
		if (colsLen) {
			var tcScale = 1/fr.totalCollisions,
				vX = fr.oldXVel, vY = fr.oldYVel,
				vAng = fr.oldAngVel,
				echain = fr.energyChain, echainCount = (echain ? echain.bodies.length : 0);

			for (var c = 0; c < colsLen; c++) {
				var col = cols[c], hit = col.hit,
					cnX = col.normalX, cnY = col.normalY,
					fPtLen = Math.sqrt(col.x*col.x + col.y*col.y),
					fPtNrmX = 0, fPtNrmY = 0;
				if (fPtLen) {
					fPtNrmX = col.x/fPtLen;//center of mass direction
					fPtNrmY = col.y/fPtLen;
				}
			
				//linear velocity added with angular velocity moment
				var avX = vX+col.y*vAng, avY = vY-col.x*vAng;
				
				if (avY < -0.8) maxDropForce = Math.min(maxDropForce, avY*fr.mass);
				
				if (hit) {
					//dynamic vs dynamic
					var hvX = hit.oldXVel, hvY = hit.oldYVel,
						hvAng = hit.oldAngVel, havX = hvX+col.hitY*hvAng, havY = hvY-col.hitX*hvAng,
				
						tfriction = 1-Math.pow(1-Math.min(1,hit.friction*fr.friction), TICK_STEP),//pow(friction, step) for tick rate independant friction
						tbounce = Math.min(1, hit.bounce*fr.bounce),
						hcScale = 1/hit.totalCollisions,
						massScale = (fr.mass*tcScale)/(hit.mass*hcScale), imassScale = 1/massScale,
						cmassScale = Math.min(1, massScale), cimassScale = Math.min(1, imassScale);
						
					if (havY < -0.8) maxDropForce = Math.min(maxDropForce, havY*hit.mass);
					if (hit.fruitId === fr.fruitId && !fr.mergeWith && !hit.mergeWith) {
						fr.mergeWith = hit;
						hit.mergeWith = fr;
						mergeFruits.push(fr);
					}

					//calculate force responses
					//fruit forces
					var fricDp = avX*cnY - avY*cnX,
						frict = fricDp*tfriction,
						bncDp = Math.max(0, -(avX*cnX + avY*cnY)),
						bounceM = tbounce*(1-cmassScale),
						bounc = bncDp*(1+bounceM), ibounc = -bncDp*(1-bounceM),
						fX = (cnX*bounc - cnY*frict)*cimassScale, fY = (cnY*bounc + cnX*frict)*cimassScale,
						hfX = (cnX*ibounc + cnY*frict)*cmassScale, hfY = (cnY*ibounc - cnX*frict)*cmassScale;

					//hit forces
					fricDp = havX*-cnY + havY*cnX;
					frict = fricDp*tfriction;
					bncDp = Math.max(0, havX*cnX + havY*cnY);
					bounceM = tbounce*(1-cimassScale);
					bounc = -bncDp*(1+bounceM); ibounc = bncDp*(1-bounceM);
					hfX += (cnX*bounc + cnY*frict)*cmassScale; hfY += (cnY*bounc - cnX*frict)*cmassScale;
					fX += (cnX*ibounc - cnY*frict)*cimassScale; fY += (cnY*ibounc + cnX*frict)*cimassScale;
				
					//linear -> angular
					var hPtLen = Math.sqrt(col.hitX*col.hitX + col.hitY*col.hitY), hPtNrmX = 0, hPtNrmY = 0;
					if (hPtLen) {
						hPtNrmX = col.hitX/hPtLen;
						hPtNrmY = col.hitY/hPtLen;
					}
					var fAng = fX*fPtNrmY - fY*fPtNrmX,
						fLin = 1-Math.abs(fAng)/Math.max(1e-6,Math.sqrt(fX*fX+fY*fY)),
						hAng = hfX*hPtNrmY - hfY*hPtNrmX,
						hLin = 1-Math.abs(hAng)/Math.max(1e-6,Math.sqrt(hfX*hfX+hfY*hfY));
					fX *= fLin; fY *= fLin;
					hfX *= hLin; hfY *= hLin;
				
					//fruit output
					fr.xVel += fX;
					fr.yVel += fY;
					fr.angVel += fAng;

					//hit output
					hit.xVel += hfX;
					hit.yVel += hfY;
					hit.angVel += hAng;
				
					//find biggest existing energy chain
					var hechain = hit.energyChain;
					if (hechain) {
						var hcount = hechain.bodies.length;
						if (hcount > echainCount) {
							echain = hechain;
							echainCount = hcount;
						}
					}
					
				} else {
					//dynamic vs static
					var ovX = 0, ovY = 0, ovAng = 0,
						fricDp = avX*cnY - avY*cnX,
						fricV = 1-Math.pow(1-Math.min(1, WALL_FRICTION*fr.friction), TICK_STEP),
						frict = fricDp*fricV,
						bncDp = Math.max(0, -(avX*cnX + avY*cnY)),
						bouncV = Math.min(1, WALL_BOUNCE*fr.bounce),
						bounc = bncDp*(1+bouncV),
						fvX = cnX*bounc - cnY*frict, fvY = cnY*bounc + cnX*frict,//force response, bounce is force in normal direction, friction is force perpendicular to normal
						fAng = fvX*fPtNrmY - fvY*fPtNrmX,//force that pushes perpendicular to center of mass results in angular velocity
						fLin = 1-Math.abs(fAng)/Math.max(1e-6,Math.sqrt(fvX*fvX+fvY*fvY));
					fAng /= fr.boundsRadius;
					fvX *= fLin; fvY *= fLin;
				
					fr.xVel += fvX;
					fr.yVel += fvY;
					fr.angVel += fAng;
				}
			}

			//build energy chain
			if (!echain) {
				echain = energyChainPool.Get();
				
				echain.last = lastEnergyChain;
				if (firstEnergyChain) lastEnergyChain.next = echain;
				else firstEnergyChain = echain;
				lastEnergyChain = echain;
			}

			if (fr.energyChain) {
				if (echain !== fr.energyChain) echain.Combine(fr.energyChain);
				
			} else {
				echain.bodies.push(fr);
				echain.energy += (Math.sqrt(vX*vX+vY*vY) + Math.abs(vAng)*fr.boundsRadius)*fr.mass;
				fr.energyChain = echain;
			}
			
			for (var c = 0; c < colsLen; c++) {
				var hit = cols[c].hit;
				if (hit) {
					var hechain = hit.energyChain;
					if (hechain) {
						//combine existing chain
						if (hechain !== echain) echain.Combine(hechain);
						
					} else {
						//add to chain
						var hvX = hit.oldXVel, hvY = hit.oldYVel;
						echain.bodies.push(hit);
						echain.energy += (Math.sqrt(hvX*hvX+hvY*hvY)+Math.abs(hit.oldAngVel)*hit.boundsRadius)*hit.mass;
						hit.energyChain = echain;
					}
				}
			}
		}
	}
	
	//play drop sound effect when object falls hard
	if (maxDropForce < -0.1 && playingSfx === -1) {
		PlaySfx(Math.floor(Math.random()*3));
	}

	//conserve energy, energy chains are collections of objects all connected via collisions during this tick
	var nextChain = firstEnergyChain;
	while (nextChain) {
		var bods = nextChain.bodies, blen = bods.length,
			newEnergy = 0;

		for (var i = 0; i < blen; i++) {
			var fr = bods[i], vX = fr.xVel, vY = fr.yVel;
			newEnergy += (Math.sqrt(vX*vX+vY*vY) + Math.abs(fr.angVel)*fr.boundsRadius)*fr.mass;
			fr.energyChain = null;
		}
		
		if (newEnergy > nextChain.energy) {
			newEnergy = nextChain.energy/newEnergy;
			for (var i = 0; i < blen; i++) {
				var fr = bods[i];
				fr.xVel *= newEnergy; fr.yVel *= newEnergy;
				fr.angVel *= newEnergy;
			}
		}
		
		var lastChain = nextChain;
		nextChain = nextChain.next;
	
		lastChain.Reset();
		energyChainPool.Return(lastChain);
	}
	
	firstEnergyChain = lastEnergyChain = null;
}



//rigidbody collision data
/**@constructor*/
function Collision() {
	//point/normal relative to collision parent position
	this.x = 0;
	this.y = 0;
	this.normalX = 0;
	this.normalY = 0;	

	//fruit hit by collision
	this.hit = null;
	
	//point relative to hit fruit position
	this.hitX = 0;
	this.hitY = 0;
}


//collection of rigidbodies touching each other, used to conserve energy
/**@constructor*/
function PhysicsEnergyChain() {
	this.energy = 0;
	this.bodies = [];
	this.next = null;
	this.last = null;
}

//combine energy chains
PhysicsEnergyChain.prototype.Combine = function(ochain) {
	this.energy += ochain.energy;
	
	var bods = ochain.bodies, blen = bods.length;
	for (var i = 0; i < blen; i++) {
		var bd = bods[i];
		bd.energyChain = this;
		this.bodies.push(bd);
	}
	
	//remove chain from linked list
	var hnext = ochain.next, hlast = ochain.last;
	if (hnext) hnext.last = hlast;
	if (hlast) hlast.next = hnext;
	if (ochain === firstEnergyChain) firstEnergyChain = (hnext ? hnext : this);
	if (ochain === lastEnergyChain) lastEnergyChain = (hlast ? hlast : this);
	
	ochain.Reset();
	energyChainPool.Return(ochain);
}

//reset energy chain
PhysicsEnergyChain.prototype.Reset = function() {
	this.energy = 0;
	this.bodies.length = 0;
	this.next = this.last = null;
}



//collider for rigidbody physics, closed collider is a convex polygon defined by clockwise line points, unclosed is capsule lines
/**@constructor*/
function Collider(pts, closed) {
	this.closed = closed;
	this.points = pts;//points must be clockwise for closed polygon
	if (closed) {
		pts.push(pts[0]);
		pts.push(pts[1]);
	}
	this.lineCount = pts.length/2-1;
	this.lengths = new Array(this.lineCount);
	
	//calculate center of mass and line lengths
	var comX = 0, comY = 0, comWt = 0,
		aX = pts[0], aY = pts[1], pi = 2;
	for (var i = 0; i < this.lineCount; i++) {
		var bX = pts[pi++], bY = pts[pi++],
			dX = bX-aX, dY = bY-aY,
			len = Math.sqrt(dX*dX+dY*dY);
		this.lengths[i] = len;
		
		comX += (aX+bX)*0.5*len;
		comY += (aY+bY)*0.5*len;
		comWt += len;
		
		aX = bX;
		aY = bY;
	}
	comX /= comWt;
	comY /= comWt;
	
	//move points to be relative to center and calculate bounding radius
	var brad = 0;
	for (var i = 0; i < pts.length; i += 2) {
		var px = pts[i]-comX, py = pts[i+1]-comY;
		pts[i] = px; pts[i+1] = py;
		brad = Math.max(brad, px*px+py*py);
	}
	this.boundsRadius = Math.sqrt(brad);
}


//get distance and normal to nearest point on collider
Collider.prototype.Nearest = function(x,y) {
	var pts = this.points, lens = this.lengths, closed = this.closed,
		pi = 2, aX = pts[0], aY = pts[1],
		ndst = 1e16, nx = 0, ny = 0,
		mdst = -1e16, mx = 0, my = 0;
	for (var l = 0, lc = this.lineCount; l < lc; l++) {
		var bX = pts[pi++], bY = pts[pi++], len = lens[l],
			dX = (bX-aX)/len, dY = (bY-aY)/len,
			rX = x-aX, rY = y-aY,
			lp = Math.max(0, Math.min(len, rX*dX + rY*dY));
		rX -= dX*lp; rY -= dY*lp;
		var dst = rX*rX+rY*rY;
		
		if (closed) {
			var face = rX*-dY + rY*dX;
			if (face > mdst) {
				mx = -dY;
				my = dX;
				mdst = face;
			}
			
			if (dst < ndst) {
				nx = rX;
				ny = rY;
				ndst = dst;
			}
			
		} else {
			if (dst < ndst) {
				nx = rX;
				ny = rY;
				ndst = dst;
			}
		}
		
		aX = bX;
		aY = bY;
	}
	if (closed && mdst < 0) {
		ndst = mdst;
		nx = mx; ny = my;
	}
	if (ndst > 0) {
		ndst = Math.sqrt(ndst);
		if (ndst !== 0) nx /= ndst; ny /= ndst;
	}
	cNormalX = nx; cNormalY = ny;
	return ndst;
}
