
var loadingPanel, mainMenuPanel, gamePanel, pausePanel, gameOverPanel, guidePanel, creditsPanel,
scoreText, scoreChanged = false, endScore, menuScores,
sfxVolume, musicVolume, combineSlider;


function InitializeUI() {
	loadingPanel = DGE("LoadingPanel");
	
	//main menu panel
	mainMenuPanel = DGE("MainMenuPanel");
	menuScores = DGE("MenuScores");
	
	//play button click
	BEC("PlayBtn", function() {
		//launch game
		StartGame();
		EV(mainMenuPanel,false);
		EV(gamePanel,true);
	});
	
	//guide click
	BEC("GuideBtn", function() {
		//open guide
		EV(mainMenuPanel,false);
		EV(guidePanel,true);
	});
	
	//credits click
	BEC("CreditsBtn", function() {
		//open credits
		EV(mainMenuPanel,false);
		EV(creditsPanel,true);
	});
	
	
	
	
	//game panel
	gamePanel = DGE("GamePanel");
	scoreText = DGE("Score");	
	
	
	//pause panel
	pausePanel = DGE("PausePanel");
	sfxVolume = DGE("SfxVol");
	musicVolume = DGE("MusicVol");
	combineSlider = DGE("CombineEffect");
	
	//resume unpause
	BEC("ResumeBtn", function() {
		sfxAudio.volume = sfxVolume.value;
		music.volume = musicVolume.value;
		combineEffectOn = parseInt(combineSlider.value);
		SaveState();
	
		music.play();
		appStatus = APPSTATUS_GAME;
		
		EV(pausePanel,false);
		EV(gamePanel,true);
	});
	
	
	//gameover panel
	gameOverPanel = DGE("GameOverPanel");
	endScore = DGE("EndScore");
	
	//play again
	BEC("AgainBtn", function() {
		ClearFruits();
		StartGame();
		EV(gameOverPanel,false);
		EV(gamePanel,true);
	});
	
	//back to main menu
	BEC("OverBackBtn", function() {
		ClearFruits();
		appStatus = APPSTATUS_MAINMENU;
		EV(gameOverPanel,false);
		EV(mainMenuPanel,true);
	});
	
	
	//guide panel
	guidePanel = DGE("GuidePanel");
	//back to main menu
	BEC("GuideBackBtn", function() {
		EV(guidePanel,false);
		EV(mainMenuPanel,true);
	});
	

	//credits panel
	creditsPanel = DGE("CreditsPanel");
	
	BEC("CreditsBackBtn", function() {
		EV(creditsPanel,false);
		EV(mainMenuPanel,true);
	});
}



/*Function: FatalCrash
Display fullscreen crash message.

Parameters:
*string* msg - HTML message.*/
function FatalCrash(msg) {
	document.body.innerHTML = "<div class='FatalCrash'>"+msg+"</div>";
}


//shortcut to get element by id
function DGE(id) {
	return document.getElementById(id);
}

//shortcut for getting element by id and adding click event listener
function BEC(id,cb) {
	document.getElementById(id).addEventListener("click",cb);
}

//set element visible
function EV(ele,vis,inlineBlock,inline) {
	ele.style.display = vis?(inlineBlock?(inline?"inline":"inline-block"):"block"):"none";
}


//update highscore list
function UpdateHighScores() {
	var t = "";
	for (var i = 0; i < highscores.length; i++) {
		if (i) t += "</br>";
		t += (i+1)+". "+highscores[i];
	}
	menuScores.innerHTML = t;
}

